import { NodeData } from './nodeData';
import { FileType } from './fileType';
import { Node } from './node';
export declare class Folder extends Node {
    constructor(data: NodeData);
    get type(): FileType.Folder;
    get extension(): null;
    get mime(): 'httpd/unix-directory';
    /**
     * Returns a clone of the folder
     */
    clone(): Folder;
}
/**
 * Interface of the folder class
 */
export type IFolder = Pick<Folder, keyof Folder>;
