import { INode } from '../files/node';
import { SortingOrder } from './sorting';
export declare enum FilesSortingMode {
    Name = "basename",
    Modified = "mtime",
    Size = "size"
}
export interface FilesSortingOptions {
    /**
     * They key to order the files by
     * @default FilesSortingMode.Name
     */
    sortingMode?: FilesSortingMode;
    /**
     * @default 'asc'
     */
    sortingOrder?: SortingOrder;
    /**
     * If set to true nodes marked as favorites are ordered on top of all other nodes
     * @default false
     */
    sortFavoritesFirst?: boolean;
    /**
     * If set to true folders are ordered on top of files
     * @default false
     */
    sortFoldersFirst?: boolean;
}
/**
 * Sort files and folders according to the sorting options
 * @param nodes Nodes to sort
 * @param options Sorting options
 */
export declare function sortNodes(nodes: readonly INode[], options?: FilesSortingOptions): INode[];
