import { IContext, ILogger, LogLevel } from './contracts';

export declare class ConsoleLogger implements ILogger {
    private context;
    constructor(context?: IContext);
    private formatMessage;
    log(level: LogLevel, message: string | Error, context: IContext): void;
    debug(message: string | Error, context?: IContext): void;
    info(message: string | Error, context?: IContext): void;
    warn(message: string | Error, context?: IContext): void;
    error(message: string | Error, context?: IContext): void;
    fatal(message: string | Error, context?: IContext): void;
}
/**
 * Create a new console logger
 *
 * @param context Optional global context which should be included for all logging messages
 */
export declare function buildConsoleLogger(context?: IContext): ILogger;
