"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const Vue = require("vue");
const MOBILE_BREAKPOINT = 1024;
const MOBILE_SMALL_BREAKPOINT = MOBILE_BREAKPOINT / 2;
const isLessThanBreakpoint = (breakpoint) => document.documentElement.clientWidth < breakpoint;
const isMobile = Vue.ref(isLessThanBreakpoint(MOBILE_BREAKPOINT));
const isSmallMobile = Vue.ref(isLessThanBreakpoint(MOBILE_SMALL_BREAKPOINT));
window.addEventListener("resize", () => {
  isMobile.value = isLessThanBreakpoint(MOBILE_BREAKPOINT);
  isSmallMobile.value = isLessThanBreakpoint(MOBILE_SMALL_BREAKPOINT);
}, { passive: true });
function useIsMobile() {
  return Vue.readonly(isMobile);
}
function useIsSmallMobile() {
  return Vue.readonly(isSmallMobile);
}
const isMobileState = Vue.readonly(isMobile);
exports.MOBILE_BREAKPOINT = MOBILE_BREAKPOINT;
exports.MOBILE_SMALL_BREAKPOINT = MOBILE_SMALL_BREAKPOINT;
exports.isMobileState = isMobileState;
exports.useIsMobile = useIsMobile;
exports.useIsSmallMobile = useIsSmallMobile;
