/**
 * SPDX-FileCopyrightText: 2019 Nextcloud GmbH and Nextcloud contributors
 * SPDX-License-Identifier: AGPL-3.0-or-later
 */
/**
 * Lists all collections
 * @param collectionId Collection ID
 */
export declare function listCollectionService(collectionId: number): Promise<any>;
/**
 * Renames a collection
 * @param collectionId Collection ID
 * @param collectionName New collection name
 */
export declare function renameCollectionService(collectionId: number, collectionName: string): Promise<any>;
/**
 * Lists all collections for a resource
 * @param resourceType Resource type
 * @param resourceId Resource ID
 */
export declare function getCollectionsByResourceService(resourceType: string, resourceId: string): Promise<any>;
/**
 * Creates a collection
 * @param resourceType Resource type
 * @param resourceId Resource ID
 * @param name Collection name
 */
export declare function createCollectionService(resourceType: string, resourceId: string, name: string): Promise<any>;
/**
 * Adds a resource to a collection
 * @param collectionId Collection ID
 * @param resourceType Resource type
 * @param resourceId Resource ID
 */
export declare function addResourceService(collectionId: number, resourceType: string, resourceId: string): Promise<any>;
/**
 * Removes a resource from a collection
 * @param collectionId Collection ID
 * @param resourceType Resource type
 * @param resourceId Resource ID
 */
export declare function removeResourceService(collectionId: number, resourceType: string, resourceId: string): Promise<any>;
/**
 * Searches for collections
 * @param query Search query
 */
export declare function searchService(query: string): Promise<any>;
