/**
 * SPDX-FileCopyrightText: 2024 Nextcloud GmbH and Nextcloud contributors
 * SPDX-License-Identifier: AGPL-3.0-or-later
 */
/**
 * Create model proxy to new v9 model (modelValue + update:modelValue) with a fallback to old model
 * @param {string} oldModelName - Name of model prop in nextcloud-vue v8
 * @param {string} oldModelEvent - Event name of model event in nextcloud-vue v8
 * @param {boolean} required - If the prop is required
 * @return {import('vue').WritableComputedRef} - model proxy
 */
export declare function useModelMigration(oldModelName: any, oldModelEvent: any, required?: boolean): import('vue').WritableComputedRef<any>;
