import { AsyncComponent, Component, default as Vue } from 'vue';
interface DialogProps {
    [index: string]: unknown;
    container?: string;
}
/**
 * Helper to spawn a Vue dialog without having to mount it from a component
 *
 * @param dialog The dialog component to spawn
 * @param props Properties to pass to the dialog
 * @param props.container Optionally pass a query selector for the dialog container element
 * @param onClose Callback when the dialog is closed
 */
export declare function spawnDialog(dialog: Component | AsyncComponent, props?: DialogProps, onClose?: (...rest: unknown[]) => void): Vue;
export {};
